using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

using OpenText.Livelink.Service.Core;

namespace HelloWorldService
{
	class Program
	{
		static int Main( string[] args )
		{
			SelfHostingServer	serviceHost;
			string				baseURL;

			DirectoryInfo		outputDir = null;

			bool				generateWSDL = false;


			if ( args.Length == 1 )
			{
				baseURL = args[ 0 ];
			}
			else if ( args.Length == 2 )
			{
				baseURL = args[ 0 ];
				outputDir = new DirectoryInfo( args[ 1 ] );
				generateWSDL = true;

				if ( !outputDir.Exists )
				{
					try
					{
						outputDir.Create();
					}
					catch ( Exception ex )
					{
						Console.WriteLine( "Unable to create {0}. ErrMsg: {1}", outputDir, ex.Message );
						return -1;
					}
				}
			}
			else
			{
				Console.WriteLine( "Usage: WcfServiceHost baseServiceURL [wsdlOutputDir]" );
				return -1;
			}

			serviceHost = new SelfHostingServer();

			try
			{
				serviceHost.StartService( baseURL, generateWSDL, outputDir );
			}
			catch ( Exception ex )
			{
				Console.WriteLine( "Error starting services: {0}", ex.Message );
				return -1;
			}

			if ( !generateWSDL )
			{
				Console.WriteLine( "Press any key to stop all services..." );
				Console.ReadKey();
			}

			serviceHost.StopService();

			return 0;
		}
	}
}
